﻿////////////////////////////////////////////////////////////////////////
// Модуль CounterpartyModal
////////////////////////////////////////////////////////////////////////
var CounterpartyModal = (function () {
    // таблица партий
    var table = null;

    // поля таблицы
    var Columns = {
        name: 0,
        address: 1,
        inn: 2,
        identifier: 3,
        kpp: 4,
        id: 5,
        fias_aoguid: 6,
        fias_houseguid: 7,
        flat: 8,
        form: 9
    };


    var getDataMatrixImage = function (id, type) {
        var url = $("#GetDataMatrixImageAjax").val();

        var result;
        $.ajax({
            url: url,
            type: "POST",
            async: false,
            data: 'id=' + id + '&type=' + type,
            dataType: 'json',
            success: function (data) {
                if (data != null && data != '') {
                    if (data.Result == true) {
                        console.info(data.Description);
                        result = data;
                    } else {
                        console.error(data.Description);
                    }
                }
            }
        });

        return result;
    }

    // загрузка таблицы партий
    var loadTable = function () {

        var url = $("#GetCounterpartyListAjax").val();

        popUpShowProgress("#counterpartyModal");

        $('#counterpartyModal').modal('show');

        table = $('#counterpartyTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                    type: "POST",
                    data: {
                    },
                    complete: function () {
                        $("#counterpartyModal .modal-dialog").stop(true, true);
                        $("#counterpartyModal .modal-dialog").animate({ "width": "1000px" }, 300, 'linear');
                        popUpShowResults("#counterpartyModal");
                    }

            },
            "bDestroy": true,
            "bFilter": false,
            "bServerSide": true,
            "bProcessing": true,
            "autoWidth": false,
            "order": [[0, "asc"]],
            "columnDefs": [
                {
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        if (StorekeeperArea) {
                            var cpId = data[Columns.id];

                            var dataCode = getDataMatrixImage(cpId, "SelectItem");

                            return "<div class=\"dropdown hor-mid\">" +
                                "<button name=\"" +
                                dataCode.name +
                                "\" class=\"btn btn-stock-table-item dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                "<img class=\"data-matrix-stock-table-button\" src=\"data:image/png;base64," +
                                dataCode.code +
                                "\">" +
                                "</button>" +
                                "</div>";
                        } else {
                            return "<div class=\"dropdown hor-mid\">" +
                                "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                "</a>" +
                                "</div>";
                        }
                    }
                }
            ]
        });

        // обрабочик нажатия на строку таблицы
        $('#counterpartyTable tbody').on('click', 'a, button', function () {
            var data = table.api().row($(this).parents('tr')).data();
            console.log(data);
            $('#customer_name').val(data[Columns.name]);
            $('#customer_address').val(data[Columns.address]);
            $('#customer_inn').val(data[Columns.inn]);
            $('#customer_identifier').val(data[Columns.identifier]);
            $('#customer_kpp').val(data[Columns.kpp]);
            $('#counterparty_id').val(data[Columns.id]);
            $('#counterparty_fias_houseguid').val(data[Columns.fias_houseguid]);
            $('#counterparty_fias_aoguid').val(data[Columns.fias_aoguid]);
            $('#counterparty_flat').val(data[Columns.flat]);
            $('#counterparty_form').val(data[Columns.form]);
            $('#counterpartyModal').modal('hide');

            scrollTo("divCustomer");

        });

    };

    var show = function () {
        loadTable();
    };

    // инициализация модуля
    var init = function () {

        $('#counterpartyModal').on('hidden.bs.modal', function () {
            popUpHideAll("#counterpartyModal");
        });

        $('#counterpartyModal').on('hidden.bs.modal', function () {
            $("#counterpartyModal .modal-dialog").stop(true, true);
            $("#counterpartyModal .modal-dialog").animate({ "width": "500px" }, 100, 'linear');
        });

        $('#btnCounterparty').on('click', function () {
            loadTable();
        });
    };

    // экспорт функций, доступных за пределами модуля
    return {
        init: init,
        show: show
    };
})();
/////////////////////////////////////////////////////////////////////////
$(document).ready(function () {

    CounterpartyModal.init();

});
///////////////////////////////////////////////////////////////////////////////
