﻿////////////////////////////////////////////////////////////////////////
// Модуль Sanner
////////////////////////////////////////////////////////////////////////
var Scanner = (function () {

    var serialNumberCallback = null;

    // событие - получен серийный номер
    var eventSerialNumber = function (cb) {
        serialNumberCallback = cb;
    };

    ///////////////////////////////////////////////////////////////////
    var init = function () {

        var url = $("#ScannerUrl").val();
        var connection = $.hubConnection(url);
        var proxy = connection.createHubProxy('ScannerHub');

        // подключение к хабу
        connection.start({ jsonp: true }).done(function () {
            console.log("Scanner proxy connected to url: " + url);
        });

        // считан серийный номер
        proxy.on('serialNumber', function (serialNumber) {
            console.log("Scanner serialNumber = " + serialNumber);
            if (serialNumberCallback) {
                serialNumberCallback(serialNumber);
            }
        });
        
        // считана команда
        proxy.on('stockCommand', function (stockCommand) {
            console.log("Scanner stockCommand = " + stockCommand);
            var btn = $("[name='" + stockCommand + "']");
            if (btn != null) {
                btn.focus();
                setTimeout(function () { btn.click(); }, 500);
            } else {
                console.log("Scanner command error! Element with \"" + stockCommand + "\" name or id not found");
            }
        });
    };
    ///////////////////////////////////////////////////////////////////
    return {
        init: init,
        eventSerialNumber: eventSerialNumber
    };
})();

///////////////////////////////////////////////////////////////////////////////
$(function () {
    Scanner.init();
});
