﻿////////////////////////////////////////////////////////////////////////
// Модуль PalletAddChild
////////////////////////////////////////////////////////////////////////
var PalletAddChild = (function () {

    var addChildCallback = null;

    var eventAddChild = function (cb) {
        addChildCallback = cb;
    };


    var onSerialNumberReceived = function (serial) {
        $('#addChildModal').modal('hide');
        if (addChildCallback != null) {
            addChildCallback(serial);
        }        
    };

    var onAddClick = function () {
        $("#addChildModal #btnAdd").click(function () {
            onSerialNumberReceived($('#child_serial').val());
            $('#child_serial').val("");
        });
    };

    var onCancelClick = function () {
        $("#addChildModal #btnCancel").click(function () {
            $('#addChildModal').modal('hide');
            $('#child_serial').val("");
        });
    };

    var onSelectClick = function () {
        $("#addChildModal #btnSelect").click(function () {
            $('#addChildModal').modal('hide');
            $('#child_serial').val("");

            PalletCases.show();
        });
    };

    var init = function () {

        onAddClick();

        onCancelClick();

        onSelectClick();

        PalletCases.init();

        PalletCases.eventSelected(onSerialNumberReceived);
    };

    return {
        init: init,
        eventAddChild: eventAddChild
    }

})();

