﻿////////////////////////////////////////////////////////////////////////
// Модуль PalletSelectBatch
////////////////////////////////////////////////////////////////////////
var PalletSelectBatch = (function () {

    var selectBatchCallback = null;

    var eventSelectBatch = function (cb) {
        selectBatchCallback = cb;
    };

    var onAddClick = function () {
        $("#selectBatchModal #btnAdd").click(function () {
            $('#selectBatchModal').modal('hide');
            if (selectBatchCallback != null) {
                selectBatchCallback($('#selectBatchModal #batch_serial').val());
            }
            $('#selectBatchModal #batch_serial').val("");
        });
    };

    var onCancelClick = function () {
        $("#selectBatchModal #btnCancel").click(function () {
            $('#selectBatchModal').modal('hide');
            $('#selectBatchModal #batch_serial').val("");
        });
    };

    var onSelectClick = function () {
        $("#selectBatchModal #btnSelect").click(function () {
            $('#selectBatchModal').modal('hide');
            $('#selectBatchModal #batch_serial').val("");
            
            PalletBatch.show();
        });
    };

    var show = function () {
        $('#selectBatchModal').modal('show');
    };

    var batchSelected = function (batch_serial) {
        if (selectBatchCallback != null) {
            selectBatchCallback(batch_serial);
        }
    };

    var init = function () {

        PalletBatch.init();

        PalletBatch.eventSelected(batchSelected);

        onAddClick();

        onCancelClick();

        onSelectClick();
    };

    return {
        init: init,
        eventSelectBatch: eventSelectBatch,
        show: show
    }

})();

