﻿// dms-production-details
//////////////////////////////////////////////////////////////////////////
var loadArticleFields = function (equipment_id, article) {
    showProgress('#divArticleFields');
    var url = $("input[name='GetArticleDetailsAjax']").val();
    $.get(url, { equipment_id: equipment_id, article: article })
            .done(function (data) {
                var res = false;
                if (data !== null && data !== '') {
                    var json = JSON.parse(data);
                    if (json.Result) {
                        var htm = "<table class=\"table table-hover color-header\" >";
                        var list = json.ArticleFieldsList;
                        for (var i = 0; i < list.length; i++) {
                            htm += "<tr><td colspan=\"2\" class=\"tr-agg-level\"><b> Уровень " + list[i].Level + "</b></td></tr>";
                            htm += "<tr><td><b>Название поля</b></td><td><b>Отображаемое имя</b></td></tr>";
                            var elements = list[i].Elements;
                            for (var j = 0; j < elements.length; j++) {
                                htm += "<tr>";
                                htm += "<td>" + elements[j].Name + "</td>";
                                htm += "<td>" + elements[j].DisplayName + "</td>";
                                htm += "</tr>";
                            }
                        }
                        htm += "</table>";

                        showDetails('#divArticleFields', htm);

                    } else {
                        showError('#divArticleFields', 'Ошибка оборудования');
                    }
                }
            })
          .fail(function () {
              showError('#divArticleFields', 'Ошибка подключения');
          });
}
//////////////////////////////////////////////////////////////////////////
var generateOrderName = function () {
    if ($('#generate_order_name').is(':checked')) {
        $('#divOrderName').find(":input").prop("readonly", true);
        $('#divOrderName').find(":input").addClass("disabled-input");
        $('#divOrderName').find(":input").prop("required", false);
    } else {
        $('#divOrderName').find(":input").prop("readonly", false);
        $('#divOrderName').find(":input").removeClass("disabled-input");
        $('#divOrderName').find(":input").prop("required", true);
    }
}

//в случае если from_erp показываем дополнительное поле "серия"
var check_erp = function () {
    $('#series_name').val('');
    if ($('#from_erp').val() == 'False') {
        $('#series_form').hide();
    }
    else {
        $('#series_form').show();
    }
}

//Функция расчета и установки значения в поле "Годен до"
//function setShelfDate()
//{
//    var create = moment($('#create_date').val(), 'DD.MM.YYYY H:mm:ss');
//    if (create.valueOf() <= 1) create = moment();
//    var days = parseInt($('#product_shelf_life').val());
//    $('#product_shelf_date').val(create.add(days, 'days').format('DD.MM.YYYY'));
//    $('#product_shelf_date').datepicker('setDate', create.toDate());
//}

//////////////////////////////////////////////////////////////////////////
$(document).ready(function () {
    $('#from_erp').on('change', check_erp);
    // открыть модальное окно для выбора Заказа из 1С
    $("#btnGetOrders").click(function () {
        $('#ordersModal').modal('show');
    });

    //Формат срока годности
    var pattern = $('#DatePattern').text().toUpperCase();

    // свернуть второстепенные панели
    $("#divCustomerPanel .showhide").click();
    $("#divSerializationParams .showhide").click();
    $("#divExtraParams .showhide").click();
    
    // проверка типа производства
    if ($('#own_prod').is(':checked')) {
        $('#divCustomer').find(":input").prop("disabled", true);
        $('#divCustomer').find(":input").prop("required", false);

        hideItem("#btnCounterparty");
    } else {
        $('#divCustomer').find(":input").prop("disabled", false);
        $('#divCustomer').find(":input").prop("required", true);
        showItem("#btnCounterparty");
    }

    // генерация имени заказа
    generateOrderName();

    // выбор собственного производства
    $('#own_prod').click(function () {
        if ($(this).is(':checked')) {
            $('#divCustomer').find(":input").prop("disabled", true);
            $('#divCustomer').find(":input").prop("required", false);

            hideItem("#btnCounterparty");
        }
    });

    // выбор контрактного производства
    $('#contract_prod').click(function () {
        if ($(this).is(':checked')) {
            $('#divCustomer').find(":input").prop("disabled", false);
            $('#divCustomer').find(":input").prop("required", true);
            showItem("#btnCounterparty");
        }
    });

    // генерация имени заказа
    $('#generate_order_name').click(function () {
        generateOrderName();
    });
    
    // запуск производства
    $("#btnStartProduction").click(function () {
        var url = $('#SaveAndStartAjax').val();

        var id = $('#id').val();
        var user_id = $('#user_id').val();
        var equipment_id = $('#equipment_id').val();
        var article = $('#article').val();

        var order_type = $("input[name='order_type']:checked").val();
        var customer_name = $('#customer_name').val();
        var customer_inn = $('#customer_inn').val();
        var customer_address = $('#customer_address').val();
        var customer_kpp = $('#customer_kpp').val();
        var series_name = $('#series_name').val();
        var from_erp = $('#from_erp').val();
        var from_erp_id = $('#from_erp_id').val();
        var product_gtin = $('#product_gtin').val();
        var product_name = $('#product_name').val();
        var product_shelf_life = $('#product_shelf_life').val();
        var sn_amount = $('#sn_amount').val();
        var sn_prefix = $('#sn_prefix').val();
        var sn_postfix = $('#sn_postfix').val();
        var batch_serial_length = $('#batch_serial_length').val();
        var alphabet = $('#alphabet').val();
        var letters = $('#letters').val();
        var batch_serial_prefix = $('#batch_serial_prefix').val();
        var generate_order_name = $('#generate_order_name').prop('checked');
        var sn_extra = $('#sn_extra').val();
        var order_name = $('#order_name').val();
        var auto_stop = $('#auto_stop').prop('checked');
        var expiry_date = $('#product_expiry_date').val();
        var production_date = $('#production_date').val();


        $("#startProductionModal #mode").val("details");
        if (id > 0) {
            $("#startProductionModal #headerDetails").html("Запуск производства №" + id);
        } else {
            $("#startProductionModal #headerDetails").html("Запуск нового производства");
        }
        
        showProgress("#startProductionModal");

        $('#startProductionModal').modal('show');

            $.post(url, {
                id: id,
                equipment_id: equipment_id,
                user_id: user_id,
                article: article,
                order_type: order_type,
                customer_name: customer_name,
                customer_inn: customer_inn,
                customer_address: customer_address,
                customer_kpp: customer_kpp,
                series_name: series_name,
                from_erp: from_erp,
                from_erp_id: from_erp_id,
                product_gtin: product_gtin,
                product_name: product_name,
                product_shelf_life: product_shelf_life,
                sn_amount: sn_amount,
                sn_prefix: sn_prefix,
                sn_postfix: sn_postfix,
                batch_serial_length: batch_serial_length,
                alphabet: alphabet,
                letters: letters,
                batch_serial_prefix: batch_serial_prefix,
                generate_order_name: generate_order_name,
                order_name: order_name,
                sn_extra: sn_extra,
                auto_stop: auto_stop,
                product_expiry_date: expiry_date,
                production_date : production_date
        })
            .done(function (data) {
                if (data != null && data != '') {
                    if (data.Fields && data.Fields[ReloadColumns.id]) {
                        $("#startProductionModal #headerDetails").html("Запуск производства №" + data.Fields[ReloadColumns.id]);
                        $("#id").val(data.Fields[ReloadColumns.id]);

                        if (data.Result == true) {
                            showResult("#startProductionModal", "Добавлено в очередь");
                            $("#startProductionModal #success").val(true);

                            setTimeout(function () {
                                $("#btnCloseProductionModal").click();
                            }, 1000);

                        } else {
                            showError('#startProductionModal', data.Description);
                        }
                    } else {
                        showError('#startProductionModal', data.Description);
                    }
                }
                else {
                    showError('#startProductionModal', 'Ошибка регистрации задания');
                }
            })
            .fail(function () {
                showError('#startProductionModal', 'Ошибка регистрации задания');
            });
    });

    $('#articleDetails').on('hidden.bs.modal', function () {
        hideAll("#divAggregation");
        hideAll("#divArticleFields");
    });

    //Вариант проверки с warning-ом
    //$('#product_expiry_date').on('change',
    //    function () {
    //        var source = $(this).val();
    //        const date = moment(source, pattern, true);
    //        if (date.isValid()) {
    //            $(this).closest('.form-group').removeClass('has-warning');
    //            $(this).closest('.form-group').addClass('has-success');
    //            $('#expiry_date_warning').fadeOut();
    //        } else {
    //            $(this).closest('.form-group').addClass('has-warning');
    //            $(this).closest('.form-group').removeClass('has-success');
    //            $('#expiry_date_warning').text('Введенный срок годности не соответствует установленному формату (' + pattern + ')');
    //            $('#expiry_date_warning').fadeIn();
    //        }
    //    });

    $("#btnGetArticleDetails").click(function () {

        var article = $("#article").val();
        if (article) {

            var equipment_id = $("#equipment_id").val();

            var url = $("input[name='GetAggregationDetailsAjax']").val();

            $("#articleDetails #headerDetails").html("Артикул '" + article + "' - детализация");

            showProgress('#divAggregation');

            $('#articleDetails').modal('show');

            $.get(url, { equipment_id: equipment_id, article: article })
                .done(function (data) {
                    var res = false;
                    if (data !== null && data !== '') {
                        var json = JSON.parse(data);
                        if (json.Result) {
                            var htm = "<table class=\"table table-hover color-header\" >";
                            htm += "<thead><tr><th>Уровень</th><th>Название</th><th>Вместимость</th></tr></thead>";

                            htm += "<tbody>";
                            var list = json.AggregationLevels;
                            for (var i = 0; i < list.length; i++) {
                                htm += "<tr><td>" + list[i].Level + "</td><td>" + list[i].Name + "</td><td>" + list[i].ChildCount + "</td></tr>";
                            }
                            htm += "</tbody>";
                            htm += "</table>";

                            showDetails('#divAggregation', htm);

                            loadArticleFields(equipment_id, article);

                        } else {
                            showError('#divAggregation', 'Ошибка оборудования');
                        }
                    }
                })
              .fail(function () {
                  showError('#divAggregation', 'Ошибка оборудования');
              });
        }
    });

    ProductionCounterparty.init();

    //кастомная валидация срока годности по паттерну из настроек производства
    jQuery.validator.addMethod("isExpiryDateValid", function () {
        var source = $('#product_expiry_date').val();
        const date = moment(source, pattern, true);
        return date.isValid();
    }, "Введенный срок годности не соответствует установленному формату (" + pattern + ")");

    //кастомная валидация даты производтства по паттерну из настроек производтства
    jQuery.validator.addMethod("isProductionDateValid", function () {
        var source = $('#production_date').val();
        if (!source) return true;
        const date = moment(source, pattern, true);
        return date.isValid();
    }, "Введенная дата производства не соответствует установленному формату (" + pattern + "), можете очистить поле чтобы оно заполнилось автоматически");

    // validation
    $(function () {

            $("#productionForm").validate({
                lang: 'ru',
                rules: {
                    customer_inn: {
                        required: true,
                        minlength: 10,
                        maxlength: 16,
                        digits: true
                    },
                    customer_name: {
                        required: true,
                        maxlength: 128
                    },
                    customer_address: {
                        required: true,
                        maxlength: 255
                    },
                    product_gtin: {
                        required: true,
                        minlength: 14,
                        maxlength: 14,
                        digits: true
                    },
                    product_name: {
                        required: true,
                        maxlength: 255
                    },
                    product_shelf_life: {
                        required: true,
                        range: [1, 65535]
                    },
                    sn_prefix: {
                        maxlength: 4
                    },
                    sn_postfix: {
                        maxlength: 4
                    },
                    batch_serial_length: {
                        max: 14,
                        min: 6
                    },
                    sn_amount: {
                        required: true,
                        range: [1, 1000000]
                    },
                    wrapper_size: {
                        max: 1000000
                    },
                    case_size: {
                        max: 1000000
                    },
                    pallet_size: {
                        max: 1000000
                    },
                    product_expiry_date: {
                        required: true,
                        isExpiryDateValid: true
                    },
                    production_date: {
                        isProductionDateValid: true
                    }
                },

            submitHandler: function (form) {
                form.submit();
            }
        });
    });

});