﻿
var EquipmentColumns = {
    equipment_name: 0,
    equipment_status_text: 1,
    equipment_status: 2,
    equipment_status_color: 3,
    equipment_id: 4
}

var LineStatus = {
    Idle: 0,
    Busy: 1,
    Inactive: 2,
    Disabled: 3
}

$(function () {

    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');


    $('#equipmentModal').on('hidden.bs.modal', function () {
        popUpHideAll("#equipmentModal");
        $("#equipmentModal .modal-dialog").stop(true, true);
        $("#equipmentModal .modal-dialog").animate({ "width": "400px" }, 100, 'linear');
    });

    $('#btnGetEquipmentFromList').on('click', function () {

        popUpShowProgress("#equipmentModal");

        $('#equipmentModal').modal('show');

        var url = $("#GetEquipmentListAjax").val();

        var table = $('#equipmentTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                type: "post"              
            },
            "initComplete": function (settings, data) {
                if (data.errorMessage) {
                    popUpShowError("#equipmentModal", data.errorMessage);
                }
                else if (table.api().data().count() > 0) {
                    $("#equipmentModal .modal-dialog").stop(true, true);
                    $("#equipmentModal .modal-dialog").animate({ "width": "500px" }, 300, 'linear');
                    popUpShowResults("#equipmentModal");
                }
            },
            "bDestroy": true,
            "bFilter": false,
            "bPaginate": false,
            "bInfo": false,
            "bServerSide": true,
            "bProcessing": false,
            "order": [[0, "asc"]],
            "columnDefs": [
                {
                    "targets": [EquipmentColumns.equipment_status],
                    "visible": false,
                    "searchable": false
                },
                {
                    "targets": [EquipmentColumns.equipment_status_color],
                    "visible": false,
                    "searchable": false
                },
                {
                    //"data": null,
                    render: function (data, type, full, meta) {
                        var status_color = full[EquipmentColumns.equipment_status_color];
                        var status_text = data;
                        return "<div class='" + status_color + "'>" + status_text + "</div>";
                    },
                    targets: EquipmentColumns.equipment_status_text
                },
                {
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        var equipment_status = full[EquipmentColumns.equipment_status];
                        var line = "";
                        if (equipment_status != LineStatus.Inactive && 
                            equipment_status != LineStatus.Disabled) {
                            line = "<div class=\"dropdown hor-mid\">" +
                                       "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                           "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                       "</a>" +
                                   "</div>";
                        }
                        return line;
                    }
                }
            ]

        });

        $('#equipmentTable tbody').on('click', 'a', function () {
            var data = table.api().row($(this).parents('tr')).data();
            var equipment_id = data[EquipmentColumns.equipment_id];
            var equipment_name = data[EquipmentColumns.equipment_name];
            var equipment_status = data[EquipmentColumns.equipment_status];
            if (equipment_status != LineStatus.Inactive) {
                $('#equipmentModal').modal('hide');
                $('#equipment_id').val(equipment_id);
                $('#equipment_name').val(equipment_name);

                var url = $('#GetArticleListAjax').val();

                $.get(url, { equipment_id: equipment_id}, function (data) {
                    if (data) {
                        $('#article').children().remove();
                        for (var i = 0; i < data.length; i++) {
                            $('#article').append($("<option></option>").attr("value", data[i]).text(data[i]));
                        }
                    }
                });
                scrollTo("divEquipmentPannel");
            }
        });        
    });
});