﻿////////////////////////////////////////////////////////////////////////
// Модуль ProductionList
////////////////////////////////////////////////////////////////////////
var ProductionList = (function () {
    /////////////////////////////////////////////////////////////////////
    var productionTable = null;
    /////////////////////////////////////////////////////////////////////
    var startModal = function (url, id) {
        $("#startMode").val("list");
        $('#id').val(id);
        loadDataListMode(url, id);
    }
    /////////////////////////////////////////////////////////////////////
    var menuStart = function (id) {
        var url = $("#StartOnlyAjax").val();
        startInListMode(url, id);
    }
    /////////////////////////////////////////////////////////////////////
    var menuStop = function (id) {
        var url = $("#StopProductionAjax").val();   

        $.post(url, { id: id })
        .done(function (data) {
            if (data !== null && data !== '' && data.Result) {
                if (data.Result == true) {
                    toastr.info("Производство №" + id + " завершено");
                } else {
                    toastr.error(data.Description);
                }
            } else {
                toastr.error("Ошибка выполнения задания");
            }
        })
      .fail(function () {
          alert('FAILED');
      });
    }
    /////////////////////////////////////////////////////////////////////
    var menuView = function (id) {
        var url = $("#View").val();
        window.location.href = url + "/" + id;
    }
    /////////////////////////////////////////////////////////////////////
    var menuEdit = function (id) {
        var url = $("#Edit").val();
        window.location.href = url + "/" + id;
    }
    /////////////////////////////////////////////////////////////////////
    var menuDelete = function (id, message) {
        var url = $("#Delete").val();
        if (showDeleteModal) {
            showDeleteModal(productionTable, url, id, message);
        }    
    }
    /////////////////////////////////////////////////////////////////////
    var getStartMenuItem = function (id) {
        return "<li>" +
                    "<a onclick=\"ProductionList.menuStart(" + id + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Запуск\">" +
                        "<i class=\"fa fa-play-circle-o table_icons action-menu-item\"></i>Запустить" +
                    "</a>" +
                "</li>";
    }
    /////////////////////////////////////////////////////////////////////
    var getStopMenuItem = function (id) {
        return "<li>" +
                    "<a onclick=\"ProductionList.menuStop(" + id + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Запуск\">" +
                        "<i class=\"fa fa-stop-circle-o table_icons action-menu-item\"></i>Завершить" +
                    "</a>" +
                "</li>";
    }
    /////////////////////////////////////////////////////////////////////
    var getEditMenuItem = function (id) {
        return "<li>" +
                    "<a onclick=\"ProductionList.menuEdit(" + id + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Редактировать\">" +
                        "<i class=\"fa fa-edit table_icons action-menu-item\"></i>Редактировать" +
                    "</a>" +
                "</li>";
    }
    /////////////////////////////////////////////////////////////////////
    var getViewMenuItem = function (id) {
        return "<li>" +
                    "<a onclick=\"ProductionList.menuView(" + id + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Просмотр\">" +
                        "<i class=\"fa fa-eye table_icons action-menu-item\"></i>Детализация" +
                    "</a>" +
                "</li>";
    }
    /////////////////////////////////////////////////////////////////////
    var getDeleteMenuItem = function (id, message) {
        return "<li>" +
                    "<a onclick=\"ProductionList.menuDelete('" + id + "','" + message + "')\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Удалить\">" +
                        "<i class=\"fa fa-trash table_icons action-menu-item\"></i>Удалить" +
                    "</a>" +
                "</li>";
    }
    /////////////////////////////////////////////////////////////////////
    var getMenu = function (status, id, message, equipmentId) {
        var menu = "";
        if (!equipmentId) {
            menu =  getEditMenuItem(id) +
                    getDeleteMenuItem(id, message);
        }
        else if (status == Status.New) {
            menu =
                    getEditMenuItem(id) +
                    getStartMenuItem(id) +                    
                    getDeleteMenuItem(id, message);

        } else if (status == Status.Generation) {
            menu =
                getViewMenuItem(id);
        }
        else if (status == Status.Enqueued) {
            menu =
                    getViewMenuItem(id) +
                    getDeleteMenuItem(id, message);

        } else if (status == Status.InProgress ||
                   status == Status.Loading ||
                   status == Status.Generation ||
                   status == Status.Starting ||
                   status == Status.Preparation) {
            menu =
                    getViewMenuItem(id) +
                    getStopMenuItem(id) +                    
                    getDeleteMenuItem(id, message);
        }
        else if (
                    status == Status.Finished ||
                    status == Status.Aggregation ||
                    status == Status.Interrupted) {
            menu =
                    getViewMenuItem(id) +
                    getDeleteMenuItem(id, message);
        }
        else if (status == Status.Done ) {
            menu =
                    getViewMenuItem(id) +
                    getStopMenuItem(id) +                    
                    getDeleteMenuItem(id, message);
        }
        else if (status == Status.Failed) {
            menu =
                    getViewMenuItem(id) +
                    getStartMenuItem(id) +                    
                    getStopMenuItem(id) +
                    getDeleteMenuItem(id, message);
        }
        else if (status == Status.ConnectionLost) {
            menu =
                    getViewMenuItem(id) +
                    getStartMenuItem(id) +
                    getStopMenuItem(id) +                    
                    getDeleteMenuItem(id, message);
        }

        return menu;
    }
    /////////////////////////////////////////////////////////////////////
    var getStatusCell = function (status_color, status_text, status, progress) {
        var line = "<div class='hor-mid list-status-box  " + status_color + "'>" + status_text + "</div>";
        if (status == Status.InProgress ||
            status == Status.Generation ) {
            line += "<div class='hor-mid'>" + progress + "%</div>";
            line += "<div class=\"progress m-t-xs full progress-small\">" +
                "<div style=\"width: " + progress + "%\" aria-valuemax=\"100\" aria-valuemin=\"0\" aria-valuenow=\"" + progress + "\" role=\"progressbar\" class=\"progress-bar progress-bar-info\">" +
                "</div>" +
            "</div>";
        } else if ( status == Status.Aggregation ||
                    status == Status.Enqueued ||
                    status == Status.Preparation ||
                    status == Status.Starting ||
                    status == Status.Loading) {
            line += "<div class='hor-mid'><div class='loader'></div></div>";
        } else if(status == Status.Done ||
            status == Status.Failed) {
            //blink_me
            line = "<div class='blinker'>" + line + "</div>";
        }

        return line;
    }
    /////////////////////////////////////////////////////////////////////
    var renderMenu = function (status, id, message, equipment_id) {
        var line = "<div class=\"dropdown hor-mid\">" +
                                    "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Действие\" href=\"#\" data-toggle=\"dropdown\">" +
                                        "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                    "</a>" +
                                    "<ul class=\"dropdown-menu hdropdown notification animated flipInX extra-margin-left\">" +

                                         getMenu(status, id, message, equipment_id) +

                                    "</ul>" +
                                "</div>";
        return line;
    }
    /////////////////////////////////////////////////////////////////////
    var startInListMode = function (url, id) {

        $("#startProductionModal #mode").val("list");
        $("#startProductionModal #headerDetails").html("Запуск производства №" + id);

        showProgress("#startProductionModal");

        $('#startProductionModal').modal('show');

        $.post(url, {
            id: id
        })
           .done(function (data) {
               if (data != null && data != '') {

                   if (data.Result == true) {
                       showResult("#startProductionModal", data.Description);

                       setTimeout(function () {
                           $("#btnCloseStartModal").click();
                       }, 1000);

                       var status = data.Fields[ReloadColumns.status];
                       var status_color = data.Fields[ReloadColumns.status_color];
                       var progress = data.Fields[ReloadColumns.progress];
                       var status_text = data.Fields[ReloadColumns.status_text];

                       // Find indexes of rows which have `Yes` in the second column
                       var items = productionTable.api().rows(function (idx, data, node) {
                           return (data[Columns.id] == id);
                       }).data();

                       var ids = [];
                       for (var i = 0; i < items.length; i++) {
                           ids.push(parseInt(items[i][Columns.id]));
                       }
                       if (ids.length > 0) {
                           var rowId = productionTable.fnFindCellRowIndexes(id, Columns.id);
                           if (rowId) {
                               var old_status = productionTable.api().cell(rowId, Columns.status).data();
                               productionTable.api().cell(rowId, Columns.status).data(status);
                               productionTable.api().cell(rowId, Columns.status_color).data(status_color);
                               productionTable.api().cell(rowId, Columns.progress).data(progress);
                               productionTable.api().cell(rowId, Columns.status_text).data(status_text);
                               if (old_status != status) {
                                   var product_name = productionTable.api().cell(rowId, Columns.product_name).data().replace(/\"/g, '');
                                   var product_gtin = productionTable.api().cell(rowId, Columns.product_gtin).data();
                                   var message = product_name + " (" + product_gtin + ")";
                                   productionTable.api().cell(rowId, Columns.action).data(renderMenu(status, id, message));
                               }
                           }
                       }
                   }
                   else {
                       showError('#startProductionModal', data.Description);
                   }
               }
               else {
                   showError('#startProductionModal', 'Ошибка оборудования');
               }
           })
           .fail(function () {
               showError('#startProductionModal', 'Ошибка оборудования');
           });
    }
    /////////////////////////////////////////////////////////////////////////
    var showHideFilter = function () {
        var show_filter = $('#show_filter').val();
        if (show_filter == 'true') {
            $('#divFilter').show();
        } else {
            $('#divFilter').hide();
        }
        loadProductionTable(null, null, null, null, null, null);
    }
    /////////////////////////////////////////////////////////////////////////
    var loadProductionTable = function (batch_serial, order_name, status, filter_date, product_gtin, product_name) {

        // очистить таблицу
        if (productionTable != null) {
            productionTable.api().clear();
        }

        $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');
        var url = $("#GetListAjax").val();
        productionTable = $('#productionTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                    type: "POST",
                    data: {
                        batch_serial: batch_serial,
                        order_name: order_name,
                        status: status,
                        filter_date: filter_date,
                        product_gtin: product_gtin,
                        product_name: product_name
                    }
            },
            "bDestroy": true,
            "bFilter": false,
            "bServerSide": true,
            "bProcessing": true,
            "autoWidth": false,
            "order": [[0, "desc"]],
            "columnDefs": [
            {
                "targets": [Columns.status],
                "visible": false,
                "searchable": false
            },
            {
                "targets": [Columns.status_color],
                "visible": false,
                "searchable": false
            },
            {
                "targets": [Columns.progress],
                "visible": false,
                "searchable": false
            },
            {
                "targets": [Columns.equipment_id],
                "visible": false,
                "searchable": false
            },
            {
                render: function (data, type, full, meta) {
                    return "<div class='text-nowrap'>" + data + "</div>";
                },
                targets: Columns.create_date
            },
            {
                render: function (data, type, full, meta) {
                    return "<div class='column_id'>" + data + "</div>";
                },
                targets: Columns.id
            },
            {
                render: function (data, type, full, meta) {
                    var id = full[Columns.id];
                    var status_color = full[Columns.status_color];
                    var status_text = data;
                    var status = full[Columns.status];
                    var progress = full[Columns.progress];
                    var line = getStatusCell(status_color, status_text, status, progress);
                    return line;
                },
                targets: Columns.status_text
            },
            {
                "orderable": false,
                "targets": -1,
                "data": null,
                render: function (data, type, full, meta) {
                    var id = full[Columns.id];
                    var status = full[Columns.status];
                    var product_name = full[Columns.product_name].replace(/\"/g, '');
                    var message = "Производство №" + id + " (" + product_name + ")";
                    var equipment_id = full[Columns.equipment_id];
                    return renderMenu(status, id, message,equipment_id);
                }
            }
            ]
        });
    }
    /////////////////////////////////////////////////////////////////////////
    var startUpdateTimer = function () {
        /////////////////////////////////////////////////////////////////////
        setInterval(function () {
            var count = productionTable.fnSettings().fnRecordsTotal();
            var cells = productionTable.api().column(Columns.status).data();

            // Find indexes of rows which have `Yes` in the second column
            var items = productionTable.api().rows(function (idx, data, node) {
                return (
                    data[Columns.status] == Status.InProgress ||
                    data[Columns.status] == Status.Preparation ||
                    data[Columns.status] == Status.Generation ||
                    data[Columns.status] == Status.Loading ||
                    data[Columns.status] == Status.Starting ||
                    data[Columns.status] == Status.Aggregation ||
                    data[Columns.status] == Status.Interrupted ||
                    data[Columns.status] == Status.Done ||
                    data[Columns.status] == Status.Failed ||
                    data[Columns.status] == Status.Enqueued) ? true : false
            }).data();

            if (items != null && items.length > 0) {

                var ids = [];
                for (var i = 0; i < items.length; i++) {
                    ids.push(parseInt(items[i][Columns.id]));
                }
                if (ids.length > 0) {
                    var url = $("#NeedReloadAjax").val();
                    $.get(url, $.param({ ids: ids }, true))
                        .done(function (data) {
                            if (data !== null && data !== '') {
                                var needReload = data.NeedReload;
                                if (needReload) {
                                    console.log("Need to reload the entire productionTable");
                                    productionTable.api().ajax.reload(null, false);
                                } else {
                                    var rows = data.Rows;
                                    if (rows != null && rows.length > 0) {
                                        for (var i = 0; i < rows.length; i++) {
                                            var row = rows[i];
                                            var id = row[ReloadColumns.id];
                                            var status = row[ReloadColumns.status];
                                            var progress = row[ReloadColumns.progress];
                                            var status_color = row[ReloadColumns.status_color];
                                            var status_text = row[ReloadColumns.status_text];
                                            var batch_serial = row[ReloadColumns.batch_serial];

                                            var rowId = productionTable.fnFindCellRowIndexes(id, Columns.id);
                                            if (rowId) {
                                                var old_status = productionTable.api().cell(rowId, Columns.status).data();
                                                if (status == Status.Generation ||
                                                    status == Status.InProgress) {
                                                    productionTable.api().cell(rowId, Columns.progress).data(progress);
                                                    productionTable.api().cell(rowId, Columns.status).data(status);
                                                    productionTable.api().cell(rowId, Columns.status_color).data(status_color);
                                                    productionTable.api().cell(rowId, Columns.status_text).data(status_text);
                                                }

                                                if (old_status && old_status != status) {
                                                    // обновить данные в таблице только если изменился статус
                                                    productionTable.api().cell(rowId, Columns.status).data(status);
                                                    productionTable.api().cell(rowId, Columns.status_color).data(status_color);
                                                    productionTable.api().cell(rowId, Columns.status_text).data(status_text);
                                                    productionTable.api().cell(rowId, Columns.batch_serial).data(batch_serial);

                                                    var product_name = productionTable.api().cell(rowId, Columns.product_name).data().replace(/\"/g, '');
                                                    var product_gtin = productionTable.api().cell(rowId, Columns.product_gtin).data();
                                                    var message = product_name + " (" + product_gtin + ")";
                                                    productionTable.api().cell(rowId, Columns.action).data(renderMenu(status, id, message));
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        })
                        .fail(function () {
                            console.log("Cannot get NeedReload for Production Table");
                        });
                }
            }
        }, 1000);
    };
    /////////////////////////////////////////////////////////////////////////
    var init = function () {

        // установить формат даты для фильтра
        $("#filter_date").datepicker({
            format: 'dd.mm.yyyy',
            language: 'ru'
        });

        showHideFilter();

        $("#btnFilter").click(function () {
            if ($('#show_filter').val() == 'true') {
                $('#show_filter').val('false');
            } else {
                $('#show_filter').val('true');
            }
            showHideFilter();

            // очистить фильтр
            $('#batch_serial').val("");
            $('#order_name').val("");
            $('#filter_date').val("");
            $('#product_gtin').val("");
            $('#product_name').val("");
        });

       

        $("#btnApplyFilter").click(function () {
            var batch_serial = $('#batch_serial').val();
            var order_name = $('#order_name').val();
            var status = $('#status_list :selected').val();
            var filter_date = $('#filter_date').val();
            var product_gtin = $("#product_gtin").val();
            var product_name = $("#product_name").val();

            loadProductionTable(batch_serial, order_name, status, filter_date, product_gtin, product_name);
        });

        startUpdateTimer();
    };
    /////////////////////////////////////////////////////////////////////////
    return {
        init: init,
        menuDelete: menuDelete,
        menuView: menuView,
        menuEdit: menuEdit,
        menuStop: menuStop,
        menuStart: menuStart
    };

})();

/////////////////////////////////////////////////////////////////////////
$(document).ready(function () {
    
    ProductionList.init();
    
});




