﻿////////////////////////////////////////////////////////////////////////
var dashboardEquipmentTable = null;
////////////////////////////////////////////////////////////////////////
var DashboardEquipmentColumns = {
    line: 0,
    status_text: 1,
    status_color: 2,
    id: 3
}
///////////////////////////////////////////////////////////////////////
var viewEquipmentDetails = function (id) {
    if (id != null) {
        var url = $("#EquipmentView").val();       
        if (url != null) {
            window.location.href = url + "/" + id;
        }
    }
}
/////////////////////////////////////////////////////////////////////
var loadDashboardEquipmentTable = function () {
    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

    if (dashboardEquipmentTable == null) {

        var url = $("#GetEquipmentListAjax").val();
        dashboardEquipmentTable = $('#dashboardEquipmentTable').dataTable({
            "ajax": {
                url,
                type: "POST",
                data: {
                }
            },
            "bSort": false,
            "scrollY": "110px",
            "scrollCollapse": true,
            "bPaginate": false,
            "bInfo": false,
            "bDestroy": false,
            "bFilter": false,
            "bServerSide": true,
            "columnDefs": [
                {
                    "width": "50%",
                    render: function (data, type, full, meta) {
                        return data;
                    },
                    targets: DashboardEquipmentColumns.line
                },
                {
                    "orderable": false,
                    "targets": [DashboardEquipmentColumns.id],
                    "visible": false,
                    "searchable": false
                },
                {
                    "width": "50%",
                    "orderable": false,
                    "targets": [DashboardEquipmentColumns.status_text],
                    "searchable": false,
                    render: function (data, type, full, meta) {
                        var color = full[DashboardEquipmentColumns.status_color];
                        return "<div class='" + color + "'>" + data + "</div>";
                        return data;
                    },
                },
                {
                    "orderable": false,
                    "targets": [DashboardEquipmentColumns.status_color],
                    "visible": false,
                    "searchable": false
                }
            ]
        });
    } else {
        dashboardEquipmentTable.api().ajax.reload();
    }
    //////////////////////////////////////////////////////////////////////////////
    $('#dashboardEquipmentTable tbody').on('click', 'tr', function () {
        var data = dashboardEquipmentTable.api().row(this).data();
        var id = data[DashboardEquipmentColumns.id];

        viewEquipmentDetails(id);

    });
}
