﻿//////////////////////////////////////////////////////////////////
var gtin2articleTable = null;
//////////////////////////////////////////////////////////////////
var GtinColumns = {
    gtin: 0,
    article: 1,
    id: 2
}
//////////////////////////////////////////////////////////////////
var DeleteAction = function (id, message) {
    var url = $("#divGtin2article #DeleteGtin2ArticleAjax").val();
    if (showDeleteModal) {
        showDeleteModal(gtin2articleTable, url, id, message);
    }
}
//////////////////////////////////////////////////////////////////
$(function () {

    var url = $('#divGtin2article #GetGtin2ArticleAjax').val();
    var equipment_id = $('#equipment_id').val();

    gtin2articleTable = $('#divGtin2article #gtin2article').dataTable({
        language: {
            "url": $("#lang").val()
        },
        "ajax": {
            url,
            type: "POST",
            data: {
                equipment_id: equipment_id
            }
        },
        "bServerSide": true,
        "order": [[0, "asc"]],
        "bPaginate": false,
        "bFilter": false,
        "info": false,
        "columnDefs": [
            {
                width: "20%",
                render: function (data, type, full, meta) {
                    return "<div class='text-nowrap'>" + data + "</div>";
                },
                targets: GtinColumns.gtin
            },
            {
                width: "20%",
                render: function (data, type, full, meta) {
                    return "<div class='text-nowrap'>" + data + "</div>";
                },
                targets: GtinColumns.article
            },
            {
                "orderable": false,
                "targets": -1,
                "data": null,
                render: function (data, type, full, meta) {
                    var id = full[GtinColumns.id];
                    var gtin = full[GtinColumns.gtin];
                    var article = full[GtinColumns.article];
                    var message = gtin + " / " + article;
                    return "<div class=\"dropdown hor-mid\">" +
                                    "<a onclick=\"DeleteAction('" + id + "','" + message + "')\" class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Удалить\" data-toggle=\"dropdown\">" +
                                        "<i class=\"fa fa-trash-o table-icons-big\"></i>" +
                                    "</a>" +
                                "</div>";
                }
            }
        ]
    });
    /////////////////////////////////////////////////////////////////////
    $("#errorModal #btnCloseErrorModal").click(function () {
        $('#errorModal #product_gtin').val("");
        $('#errorModal').modal('hide');
    });
    /////////////////////////////////////////////////////////////////////
    $('#divGtin2article #btnAdd').on('click', function () {
        var url = $('#divGtin2article #AddGtin2ArticleAjax').val();
        var gtin = $('#divGtin2article #product_gtin').val();
        var article = $('#divGtin2article #articles :selected').text();

        if (gtin && article) {

            $.post(url, {
                equipment_id: equipment_id,
                gtin: gtin,
                article: article
            })
            .done(function (data) {
                $("#divGtin2article #product_gtin").val("");
                if (data != null && data != '') {
                    if (data.ErrorMessage) {
                        $("#errorModal #error").html('<h3><span class=\"error\"> ' + data.ErrorMessage + ' </span></h3>');
                        $('#errorModal').modal('show');
                    }
                    else {
                        if (gtin2articleTable) {
                            gtin2articleTable.api().ajax.reload();
                        }
                    }
                }
            })
            .fail(function () {
                $("#divGtin2article #product_gtin").val("");
                $("#errorModal #error").html('<h3><span class=\"error\"> Внутренняя ошибка системы </span></h3>');
            });
        }
    });
});