﻿/////////////////////////////////////////////////////////////////////
var equipmentTable = null;
/////////////////////////////////////////////////////////////////////
var EquipmentColumns = {
    name: 0,
    type_text: 1,
    ip: 2,
    port: 3,
    status_text: 4,
    status_color: 5,
    action: 6
}

var EditAction = function (id) {
    var url = $("#divEquipmentList #Edit").val();
    window.location.href = url + "/" + id;
}

var ViewAction = function (id) {
    var url = $("#divEquipmentList #View").val();
    window.location.href = url + "/" + id;
}

var DeleteAction = function (id, message) {
    var url = $("#divEquipmentList #Delete").val();
    if (showDeleteModal) {
        showDeleteModal(equipmentTable, url, id, message);
    }
}

/////////////////////////////////////////////////////////////////////
var getEditMenuItem = function (id) {
    return "<li>" +
                "<a onclick=\"EditAction(" + id + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Редактировать\">" +
                    "<i class=\"fa fa-edit table_icons action-menu-item\"></i>Редактировать" +
                "</a>" +
            "</li>";
}
/////////////////////////////////////////////////////////////////////
var getViewMenuItem = function (id) {
    return "<li>" +
                "<a onclick=\"ViewAction(" + id + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Детализация\">" +
                    "<i class=\"fa fa-eye table_icons action-menu-item\"></i>Детализация" +
                "</a>" +
            "</li>";
}
/////////////////////////////////////////////////////////////////////
var getDeleteMenuItem = function (id, message) {
    return "<li>" +
                "<a onclick=\"DeleteAction('" + id + "','" + message + "')\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Удалить\">" +
                    "<i class=\"fa fa-trash table_icons action-menu-item\"></i>Удалить" +
                "</a>" +
            "</li>";
}
/////////////////////////////////////////////////////////////////////
var getMenu = function (data) {
    var id = data[EquipmentColumns.action];
    var name = data[EquipmentColumns.name];
    var ip = data[EquipmentColumns.ip];
    var port = data[EquipmentColumns.port];

    var message = name + " (" + ip + ":" + port + ")";

    var menu =
                getEditMenuItem(id) +
                getViewMenuItem(id) +
                getDeleteMenuItem(id, message);
    return menu;
}


$(function () {

    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

    var url = $("#divEquipmentList #GetListAjax").val();

    equipmentTable = $('#divEquipmentList #equipmentTable').dataTable({
        language: {
            "url": $("#lang").val()
        },
        "sAjaxSource": url,
        "bServerSide": true,
        "bProcessing": true,
        "order": [[0, "asc"]],
        "columnDefs": [
            {
                "targets": EquipmentColumns.status_color,
                visible: false
            },
            {
                render: function (data, type, full, meta) {
                    var status_color = full[EquipmentColumns.status_color];
                    return "<div class='" + status_color + "'>" + data + "</div>";
                },
                targets: EquipmentColumns.status_text
            },
            {
                "orderable": false,
                "targets": -1,
                "data": null,
                render: function (data, type, full, meta) {
                    return "<div class=\"dropdown hor-mid\">" +
                                "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Действие\" href=\"#\" data-toggle=\"dropdown\">" +
                                    "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                "</a>" +
                                "<ul class=\"dropdown-menu hdropdown notification animated flipInX extra-margin-left\">" +

                                     getMenu(full) +

                                "</ul>" +
                            "</div>";
                }
            }
        ],
        initComplete: function () {
            var api = this.api();
            $('#divEquipmentList #equipmentTable input')
                .off('.DT')
                .on('keyup.DT', function (e) {
                    if (e.keyCode === 13 || this.value.length === 0) {
                        api.search(this.value).draw();
                    }
                });
        }
    });

});