﻿
var showError = function (container, message) {
    $(container + " #spinner").hide();
    $(container + " #error").html('<h3><span class=\"error\"> ' + message + ' </span></h3>');
    $(container + " #error").show();
}

var showResult = function (container, message) {
    $(container + " #spinner").hide();
    $(container + " #error").hide();
    $(container + " #result").html(message);
    $(container + " #result").show();
}

var showProgress = function (container) {
    $(container + " #spinner").show();
    $(container + " #error").hide();
    $(container + " #result").hide();
}

var ArticleColumns = {
    name: 0,
    article_details: 1,
    aggregation_details: 2
}

var onArticleDetails = function (article) {
    var equipment_id = $("#equipment_id").val();

    var url = $("input[name='GetArticleDetailsAjax']").val();

    $("#articleDetails #headerDetails").html("Артикул '" + article + "' - детализация");

    showProgress('#articleDetails');

    $('#articleDetails').modal('show');

    $.get(url, { equipment_id: equipment_id, article: article })
        .done(function (data) {
            var res = false;
            if (data !== null && data !== '') {
                var json = JSON.parse(data);
                if (json.Result) {
                    var htm = "<table class=\"table table-hover color-header\" >";
                    var list = json.ArticleFieldsList;
                    for (var i = 0; i < list.length; i++) {

                        var description = "";
                        if (list[i].Level == 0) description = " - Вторичная упаковка";
                        else if (list[i].Level == 1) description = " - Бандероль";
                        else if (list[i].Level == 2) description = " - Гофрокороб";
                        else if (list[i].Level == 3) description = " - Паллета";

                        htm += "<tr><td colspan=\"2\" class=\"tr-agg-level\"><b> Уровень " + list[i].Level + description + "</b></td></tr>";
                        htm += "<tr><td><b>Название поля</b></td><td><b>Отображаемое имя</b></td></tr>";
                        var elements = list[i].Elements;
                        for (var j = 0; j < elements.length; j++) {
                            htm += "<tr>";
                            htm += "<td>" + elements[j].Name + "</td>";
                            htm += "<td>" + elements[j].DisplayName + "</td>";
                            htm += "</tr>";
                        }
                    }
                    htm += "</table>";

                    showResult('#articleDetails', htm);

                } else {
                    showError('#articleDetails', 'Ошибка оборудования');
                }
            }
        })
      .fail(function () {
          showError('#articleDetails', 'Ошибка подключения');
      });
}

var onAggregationDetails = function (article) {
    var equipment_id = $("#equipment_id").val();

    var url = $("input[name='GetAggregationDetailsAjax']").val();

    $("#aggregationDetails #headerDetails").html("Артикул '" + article + "' - агрегация");

    showProgress('#aggregationDetails');

    $('#aggregationDetails').modal('show');

    $.get(url, { equipment_id: equipment_id, article: article })
        .done(function (data) {
            var res = false;
            if (data !== null && data !== '') {
                var json = JSON.parse(data);
                if (json.Result) {
                    var htm = "<table class=\"table table-hover color-header\" >";
                    htm += "<thead><tr><th>Уровень</th><th>Название</th><th>Вместимость</th></tr></thead>";

                    htm += "<tbody>";
                    var list = json.AggregationLevels;
                    for (var i = 0; i < list.length; i++) {
                        htm += "<tr><td>" + list[i].Level + "</td><td>" + list[i].Name + "</td><td>" + list[i].ChildCount + "</td></tr>";
                    }
                    htm += "</tbody>";
                    htm += "</table>";

                    showResult('#aggregationDetails', htm);

                } else {
                    showError('#aggregationDetails', 'Ошибка оборудования');
                }
            }
        })
      .fail(function () {
          showError('#aggregationDetails', 'Ошибка подключения');
      });
}

var loadArticles = function () {

    var table = $('#articleTable').dataTable({
        language: {
            "url": $("#lang").val()
        },
        "destroy": true,
        "bPaginate": false,
        "bInfo": false,
        "bServerSide": false,
        "bProcessing": false,
        "bFilter": false,
        "order": [[0, "asc"]],
        "bAutoWidth": false,
        "columnDefs": [
            {
                "targets": ArticleColumns.name,
                "width": "60%"
            },
            {
                "width": "20%",
                "className": "text-center",
                "orderable": false,
                "targets": ArticleColumns.article_details,
                "data": null,
                render: function (data, type, full, meta) {
                    return "<a class=\"text-center\" onclick=\"onArticleDetails('" + full[ArticleColumns.name] + "')\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Детализация\"><i class=\"fa fa fa-eye table_icons\"></i></a>";
                }
            },
            {
                "width": "20%",
                "className": "text-center",
                "orderable": false,
                "targets": ArticleColumns.aggregation_details,
                "data": null,
                render: function (data, type, full, meta) {
                    return "<a class=\"text-center\" onclick=\"onAggregationDetails('" + full[ArticleColumns.name] + "')\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Агрегация\"><i class=\"fa fa fa-cubes table_icons\"></i></a>";
                }
            }
        ]
    });
}

$(document).ready(function () {

    // свернуть второстепенные панели
    $("#divArticles .showhide").click();

    loadArticles();

    $('#btnArticleListReload').click(function () {

        loadArticles();
    });

    $('#btnAggregationDetails').click(function () {
        var article = $('#article :selected').val();
        var equipment_id = $("#equipment_id").val();

        var url = $("input[name='controllerGetAggregationDetails']").val();

        $("#aggregationDetails #headerDetails").html("Артикул '" + article + "' - агрегация");

        showProgress('#aggregationDetails');

        $('#aggregationDetails').modal('show');

        $.get(url, { equipment_id: equipment_id, article: article })
            .done(function (data) {
                var res = false;
                if (data !== null && data !== '') {
                    var json = JSON.parse(data);
                    if (json.Result) {
                        var htm = "<table class=\"table table-bordered table-hover color-header\" >";
                        htm += "<thead><tr><th>Уровень</th><th>Название</th><th>Вместимость</th></tr></thead>";

                        htm += "<tbody>";
                        var list = json.AggregationLevels;
                        for (var i = 0; i < list.length; i++) {
                            htm += "<tr><td>" + list[i].Level + "</td><td>" + list[i].Name + "</td><td>" + list[i].ChildCount + "</td></tr>";
                        }
                        htm += "</tbody>";
                        htm += "</table>";

                        showResult('#aggregationDetails', htm);

                    } else {
                        showError('#aggregationDetails', 'Ошибка оборудования');
                    }
                }
            })
          .fail(function () {
              showError('#aggregationDetails', 'Ошибка подключения');
          });
    });
});