﻿/////////////////////////////////////////////////////////////////////
var userTable = null;
/////////////////////////////////////////////////////////////////////
var UserColumns = {
    last_name: 0,
    first_name: 1,
    role_name: 2,
    login: 3,
    email: 4,
    action: 5
}
/////////////////////////////////////////////////////////////////////
var EditAction = function (id) {
    var url = $("#Edit").val();
    window.location.href = url + "/" + id;
}
/////////////////////////////////////////////////////////////////////
var DeleteAction = function (id, message) {
    var url = $("#Delete").val();
    if (showDeleteModal) {
        showDeleteModal(userTable, url, id, message);
    }
}
/////////////////////////////////////////////////////////////////////
var getEditMenuItem = function (id) {
    return "<li>" +
                "<a onclick=\"EditAction(" + id + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Редактировать\">" +
                    "<i class=\"fa fa-edit table_icons action-menu-item\"></i>Редактировать" +
                "</a>" +
            "</li>";
}
/////////////////////////////////////////////////////////////////////
var getDeleteMenuItem = function (id, message) {
    return "<li>" +
                "<a onclick=\"DeleteAction('" + id + "','" + message + "')\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Удалить\">" +
                    "<i class=\"fa fa-trash table_icons action-menu-item\"></i>Удалить" +
                "</a>" +
            "</li>";
}
/////////////////////////////////////////////////////////////////////
var getMenu = function (data) {
    var id = data[UserColumns.action];
    var first_name = data[UserColumns.first_name];
    var last_name = data[UserColumns.last_name];
    var role_name = data[UserColumns.role_name];

    var message = first_name + " " + last_name + " (" + role_name + ")";

    var menu =
                getEditMenuItem(id) +
                getDeleteMenuItem(id, message);
    return menu;
}
/////////////////////////////////////////////////////////////////////
$(function () {

    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

    var url = $("#GetListAjax").val();

    userTable = $('#userTable').dataTable({
        language: {
            "url": $("#lang").val()
        },
        "sAjaxSource": url,
        "bServerSide": true,
        "bProcessing": true,
        "order": [[0, "asc"]],
        "columnDefs": [
            {
                "orderable": false,
                "targets": -1,
                "data": null,
                render: function (data, type, full, meta) {
                    return "<div class=\"dropdown hor-mid\">" +
                                "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Действие\" href=\"#\" data-toggle=\"dropdown\">" +
                                    "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                "</a>" +
                                "<ul class=\"dropdown-menu hdropdown notification animated flipInX extra-margin-left\">" +

                                     getMenu(full) +

                                "</ul>" +
                            "</div>";
                }
            }
        ],
        initComplete: function () {
            var api = this.api();
            $('#userTable input')
                .off('.DT')
                .on('keyup.DT', function (e) {
                    if (e.keyCode === 13 || this.value.length === 0) {
                        api.search(this.value).draw();
                    }
                });
        }
    });

});